## klatexformula 3.3.0~beta

=== CMakeLists.txt ===
# #################################### #
# CMake project file for klatexformula #
# #################################### #
# $Id: CMakeLists.txt 916 2014-08-24 22:17:20Z phfaist $
# #################################### #
cmake_minimum_required(VERSION 2.6.4)

PROJECT(klatexformula)

# Set up CMAKE properly
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(KLF_ROOT_CMAKE_READ TRUE CACHE INTERNAL "Can be queried to see if the root CMakeLists.txt was read")

# Read project version
file(READ "VERSION" klf_ver)
string(STRIP "${klf_ver}" KLF_VERSION)
message(STATUS "KLatexFormula Version ${KLF_VERSION}")
option(KLF_WELCOME_MSG_SILENT "Don't display welcome message" OFF)
if(NOT KLF_WELCOME_MSG_SILENT)
  message(STATUS "
   Welcome to the klatexformula build script. This CMake script will configure
   the klatexformula ${KLF_VERSION} build process for your system.

   Some settings will have to be detected. This script should be able to detect
   the correct settings for most systems. However, you may want to tune and even
   fine-tune this configuration in order to build and install the compenents you
   would like, and install them at your preferred locations.

   Each status message displays a default or detected value for a setting. In
   capital letters is given the corresponding CMake cache variable name, in case
   you want to change the setting. With command-line cmake, you can set a
   variable with:
     cmake <source-dir> -D<VARIABLE_NAME>=<VALUE>
   In most cases values are just 'ON' or 'OFF'. In some other cases they are paths.

   But don't worry, most default values should be fine. Unless an error was
   reported during this script, you can type
       make
   and
       sudo make install
   to install klatexformula on your system.
   
   For more options and help:
      - look at the stored cache variable documentation (displayed eg. by cmake-gui
        and ccmake, or directly in the CMakeCache.txt file)
      - take a look at
http://klatexformula.sourceforge.net/klfwiki/index.php/User_Manual:Downloading_%26_Installing

   And have a lot of fun!

")
  message(STATUS "Displayed welcome message (KLF_WELCOME_MSG_SILENT)")
else(NOT KLF_WELCOME_MSG_SILENT)
  message(STATUS "Skipped welcome message (KLF_WELCOME_MSG_SILENT)")
endif(NOT KLF_WELCOME_MSG_SILENT)


# Extract KLF Version from VERSION file
set(klfversion_regex "([0-9]+)\\.([0-9]+)\\.([0-9]+)(.*)")
string(REGEX REPLACE "${klfversion_regex}" "\\1" KLF_VERSION_MAJ "${KLF_VERSION}")
string(REGEX REPLACE "${klfversion_regex}" "\\2" KLF_VERSION_MIN "${KLF_VERSION}")
string(REGEX REPLACE "${klfversion_regex}" "\\3" KLF_VERSION_REL "${KLF_VERSION}")
string(REGEX REPLACE "${klfversion_regex}" "\\4" KLF_VERSION_SUFFIX "${KLF_VERSION}")

# The version that the libraries will be tagged with
set(KLF_LIB_VERSION "${KLF_VERSION_MAJ}.${KLF_VERSION_MIN}")

include(KLFUtil)


# Warn the user for defined cache variables that are not standard,
# i.e. may be a user's typo
include(klfValidOptions)



# Set some project settings
# -------------------------

message(STATUS "")
message(STATUS "[BUILD SETTINGS]")

KLFGetCMakeVarChanged(CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE "Release" CACHE STRING "(FOR DEVELOPERS:) Build configuration (Debug|Release)")
mark_as_advanced(CLEAR CMAKE_BUILD_TYPE)
if(NOT CMAKE_BUILD_TYPE AND klf_first_CMAKE_BUILD_TYPE)
  # force to "Release" the first time if empty
  set(CMAKE_BUILD_TYPE "Release"
		      CACHE STRING "(FOR DEVELOPERS:) Build configuration (Debug|Release)" FORCE)
endif(NOT CMAKE_BUILD_TYPE AND klf_first_CMAKE_BUILD_TYPE)
message(STATUS "Build Type: ${CMAKE_BUILD_TYPE} (CMAKE_BUILD_TYPE)")
KLFCMakeSetVarChanged(CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(default_klf_debug TRUE)
else(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(default_klf_debug FALSE)
endif(CMAKE_BUILD_TYPE STREQUAL "Debug")
#KLFDeclareCacheVarOptionFollowComplex1(specificoption cachetype cachestring updatenotice calcoptvalue depvar1)
KLFDeclareCacheVarOptionFollowComplex1(KLF_DEBUG
	BOOL "Enable debugging messages"  # cache
	ON                                # updatenotice enabled
	"${default_klf_debug}"            # (possibly new) calculated value
	CMAKE_BUILD_TYPE                  # dependency variable
)
if(KLF_DEBUG)
  message(STATUS "Enabling debugging messages (KLF_DEBUG)")
endif(KLF_DEBUG)
if(WIN32)
  set(klf_default_debug_postfix "d")
elseif(APPLE)
  set(klf_default_debug_postfix "_debug")
else(WIN32)
  set(klf_default_debug_postfix "")  
endif(WIN32)
set(CMAKE_DEBUG_POSTFIX "${klf_default_debug_postfix}"
	    CACHE STRING "Suffix to add to target names when built in 'Debug' build configuration")
mark_as_advanced(CMAKE_DEBUG_POSTFIX)


# experimental features
option(KLF_EXPERIMENTAL
  "DEVELOPERS ONLY. Enable experimental unstable features (NOT recommended for regular use!)"
  off)
mark_as_advanced(KLF_EXPERIMENTAL)
if(KLF_EXPERIMENTAL)
  KLFNote("WARNING: Experimental features are unstable and are meant only for developers!! Use at your risk!!")
  message(STATUS "Enabling experimental features (KLF_EXPERIMENTAL)")
endif(KLF_EXPERIMENTAL)


# see if user specified a QT_QMAKE_EXECUTABLE and set QT_QMAKE_EXECUTABLE_FINDQT too (FindQt4 bug?)
if(QT_QMAKE_EXECUTABLE AND NOT QT_QMAKE_EXECUTABLE_FINDQT)
  set(QT_QMAKE_EXECUTABLE_FINDQT "${QT_QMAKE_EXECUTABLE}" CACHE STRING "Qt QMake executable path" FORCE)
endif(QT_QMAKE_EXECUTABLE AND NOT QT_QMAKE_EXECUTABLE_FINDQT)

# Find Qt 4 and Include it
find_package(Qt4 4.5.0 COMPONENTS QtCore QtGui REQUIRED)

if(NOT QT4_FOUND)
  mark_as_advanced(CLEAR QT_QMAKE_EXECUTABLE)
  message(FATAL_ERROR
    "Didn't find Qt4. Try setting the QT_QMAKE_EXECUTABLE (and/or QT_QMAKE_EXECUTABLE_FINDQT) cache variable(s)." )
endif(NOT QT4_FOUND)

# Current Qt Version "MAJ.MIN"
set(KLF_CMAKE_QTVERSION "${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}" CACHE INTERNAL "Qt Version, Maj.Min")


# variables that FindQt obviously forgets to set to advanced
mark_as_advanced(QT_QTMOTIF_INCLUDE_DIR QT_QTMOTIF_LIBRARY_DEBUG QT_QTMOTIF_LIBRARY_RELEASE)
if(WIN32)
  mark_as_advanced(CLEAR QT_QMAKE_EXECUTABLE_FINDQT)
endif(WIN32)

# Bug: on Mac OS X, with homebrew, qt frameworks are symlinks and it's a hell of
# install_name_tool's to get names and references right. This is an additional directory
# which Qt libraries might report being in, although they might only be symlinks there.
KLFCMakeDebug("QT_LIBRARY_DIR is ${QT_LIBRARY_DIR}")
if(NOT QT_HOMEBREW_ALT_LIB_DIR AND QT_LIBRARY_DIR MATCHES "^/usr/local/Cellar/.*")
  # homebrew
  set(QT_HOMEBREW_ALT_LIB_DIR "/usr/local/lib" CACHE STRING
    "Alternative directory where Qt libraries could report living in with otool -L QtCore.framework")
  message(STATUS
    "Detected homebrew Qt. Set QT_HOMEBREW_ALT_LIB_DIR for proper importing of Qt frameworks into final bundle."
    )
endif(NOT QT_HOMEBREW_ALT_LIB_DIR AND QT_LIBRARY_DIR MATCHES "^/usr/local/Cellar/.*")




#KLFDeclareCacheVarOptionCondition(specificoption cachetype cachestring updatenoticestring condition forcedvalue defaultvalue)
KLFDeclareCacheVarOptionCondition(KLF_BUILD_TOOLS
	BOOL "Build klatexformula tools library (klftools)"          # cache info
	"Not building klftools library... should never happen."  # update notify message
	1              # the condition (1=no condition)
	OFF            # the forced value if condition is not met
	1              # the default value at beginning
)
if(KLF_BUILD_TOOLS)
  message(STATUS "Will build the klftools library (KLF_BUILD_TOOLS)")
else(KLF_BUILD_TOOLS)
  message(FATAL_ERROR "There is nothing to build. You must set at least KLF_BUILD_TOOLS.")
endif(KLF_BUILD_TOOLS)

set(KLF_BUILD_TOOLSDESPLUGIN TRUE CACHE BOOL "Build Qt Designer Plugin for klftools library widgets")
mark_as_advanced(KLF_BUILD_TOOLSDESPLUGIN)
# ...
KLFTestCondition(_klf_allow_toolsdesplugin
  "KLF_BUILD_TOOLS AND NOT KLF_LIBKLFBACKEND_STATIC AND NOT KLF_LIBKLFTOOLS_STATIC")
KLFDeclareCacheVarOptionCondition(KLF_BUILD_TOOLSDESPLUGIN
	BOOL "Build klatexformula tools designer plug-in; requires building dynamic libraries."          # cache info
	"Build klatexformula tools designer plug-in requires building dynamic libraries.
    Not building the klftools designer plug-in."  # update notify message
	_klf_allow_toolsdesplugin  # the condition
	OFF                        # the forced value if condition is not met
	${KLF_BUILD_TOOLS}         # the default value at beginning
)
mark_as_advanced(KLF_BUILD_TOOLSDESPLUGIN) # advanced...
if(KLF_BUILD_TOOLSDESPLUGIN)
  message(STATUS "Will build the klftools designer plugin library (KLF_BUILD_TOOLSDESPLUGIN)")
else(KLF_BUILD_TOOLSDESPLUGIN)
  message(STATUS "Will not build the klftools designer plugin library (KLF_BUILD_TOOLSDESPLUGIN)")
endif(KLF_BUILD_TOOLSDESPLUGIN)


#KLFDeclareCacheVarOptionCondition(specificoption cachetype cachestring updatenoticestring condition forcedvalue defaultvalue)
KLFDeclareCacheVarOptionCondition(KLF_BUILD_BACKEND
	BOOL "Build klatexformula backend library (klfbackend)"                  # cache info
	"Building klfbackend library requires klftools. Not building klfbackend library."  # update notify message
	KLF_BUILD_TOOLS       # the condition
	OFF                   # the forced value if condition is not met
	TRUE                  # the default value at beginning
)
if(KLF_BUILD_BACKEND)
  message(STATUS "Will build the klfbackend library (KLF_BUILD_BACKEND)")
else(KLF_BUILD_BACKEND)
  message(STATUS "Will not build the klfbackend library (KLF_BUILD_BACKEND)")
endif(KLF_BUILD_BACKEND)

#KLFDeclareCacheVarOptionCondition(specificoption cachetype cachestring updatenoticestring condition forcedvalue defaultvalue)
KLFDeclareCacheVarOptionCondition(KLF_BUILD_BACKEND_AUTO
	BOOL "Build klatexformula autonomous backend library (klfbackend_auto)"          # cache info
	"Not building klfbackend_auto library... should never happen."  # update notify message
	1              # the condition (1=no condition)
	OFF            # the forced value if condition is not met
	1              # the default value at beginning
)
if(KLF_BUILD_BACKEND)
  message(STATUS "Will build autonomous klfbackend_auto without klftools dependency (KLF_BUILD_BACKEND_AUTO)")
else(KLF_BUILD_BACKEND)
  message(STATUS "Will not build autonomous klfbackend_auto without klftools dependency (KLF_BUILD_BACKEND_AUTO)")
endif(KLF_BUILD_BACKEND)


#KLFDeclareCacheVarOptionCondition(spec.option cachetype cachestr updatemsg cond. forceval def.val.)
KLFDeclareCacheVarOptionCondition(KLF_BUILD_GUI
	BOOL "Build klatexformula GUI (klfapp+klatexformula), requires klftools and klfbackend." # cache info
	"Building klatexformula GUI requires klftools and klfbackend libraries. Not building GUI." # notify message
	"KLF_BUILD_BACKEND AND KLF_BUILD_TOOLS"  # the condition
	OFF                                      # the forced value if condition is not met
	TRUE                                     # the default value at beginning (here this is a boolean)
)
if(KLF_BUILD_GUI)
  message(STATUS "Will build the GUI interface (klatexformula, klfapp) (KLF_BUILD_GUI)")
else(KLF_BUILD_GUI)
  message(STATUS "Will not build the GUI interface (klatexformula, klfapp) (KLF_BUILD_GUI)")
endif(KLF_BUILD_GUI)


#KLFDeclareCacheVarOptionCondition(spec.option cachetype cachestr updatemsg cond. forceval def.val.)
KLFDeclareCacheVarOptionCondition(KLF_BUILD_PLUGINS
	BOOL "Build klatexformula plugins; requires klftools, klfbackend and GUI" # cache info
	"Building klatexformula plugins requires klatexformula GUI. Not building plugins." # notify message
	"KLF_BUILD_GUI"                    # the condition (GUI depends on klftools and Qt4)
	OFF                                # the forced value if condition is not met
	${KLF_BUILD_GUI}                   # the default value at beginning (here this is a boolean)
)
if(KLF_BUILD_PLUGINS)
  message(STATUS "Will build klatexformula plugins (KLF_BUILD_PLUGINS)")
else(KLF_BUILD_PLUGINS)

=== src/CMakeLists.txt ===
# ######################################## #
# CMake project file for klatexformula/src #
# ######################################## #
# $Id: CMakeLists.txt 916 2014-08-24 22:17:20Z phfaist $
# ######################################## #

if(KLF_MACOSX_BUNDLES)
  set(KLF_MACOSXDIR "${CMAKE_CURRENT_SOURCE_DIR}/macosx")

  include(KLFMacBundle)
endif(KLF_MACOSX_BUNDLES)

if(WIN32)
  # Extra linker flags for win32 compilation
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--enable-auto-import")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--enable-auto-import")
endif(WIN32)


# include these subprojects...

if(KLF_BUILD_TOOLS)
  add_subdirectory(klftools)
endif(KLF_BUILD_TOOLS)

add_subdirectory(klfbackend)

# Re-Include what we need from Qt for GUI KLF core+gui+xml+sql(+dbus)
set(QT_USE_QTXML TRUE)
set(QT_USE_QTSQL TRUE)
if(KLF_USE_DBUS)
  set(QT_USE_QTDBUS TRUE)
endif(KLF_USE_DBUS)
set(QT_USE_QTUITOOLS TRUE)
include(${QT_USE_FILE})



if(NOT KLF_BUILD_GUI)
  return()
endif(NOT KLF_BUILD_GUI)


# Sources
set(klfapp_SRCS
	klfconfig.cpp
	klflatexsymbols.cpp
	klfstyle.cpp
	klflibentryeditor.cpp
	klflibbrowser.cpp
	klflib.cpp
	klflibview.cpp
	klflibdbengine.cpp
	klfliblegacyengine.cpp
	klfmime.cpp
	klfmainwin.cpp
	klfsettings.cpp
	klfstylemanager.cpp
	klfmain.cpp
	klfcmdiface.cpp
	klfuiloader.cpp
)
# Headers
#  * with QObject classes (needs moc)
set(klfapp_MOCHEADERS
	klflatexsymbols.h
	klflatexsymbols_p.h
	klflibentryeditor.h
	klflibbrowser.h
	klflibbrowser_p.h
	klflib.h
	klflibview.h
	klflibview_p.h
	klflibdbengine.h
	klflibdbengine_p.h
	klfliblegacyengine.h
	klfliblegacyengine_p.h
	klfmime.h
	klfmime_p.h
	klfmainwin.h
	klfmainwin_p.h
	klfsettings.h
	klfsettings_p.h
	klfstylemanager.h
	klfcmdiface.h
	klfuiloader_p.h
        klfautoupdater.h
)
#  * all headers
set(klfapp_HEADERS
	klfmain.h
	klfconfig.h
	klfconfig_p.h
	klfstyle.h
	klfpluginiface.h
	klflib_p.h
	klfuiloader.h
	${klfapp_MOCHEADERS}
)
# UI Forms
set(klfapp_UIS
	klflatexsymbols.ui
	klflibbrowser.ui
	klflibentryeditor.ui
	klflibopenresourcedlg.ui
	klflibrespropeditor.ui
	klfliblocalfilewidget.ui
	klflibnewsubresdlg.ui
	klfmainwin.ui
	klfsettings.ui
	klfstylemanager.ui
	klfaboutdialog.ui
	klfwhatsnewdialog.ui
	klflibexportdialog.ui
)

# Special adjustments for certain platforms and options
# * Windows
if(WIN32)
  list(APPEND klfapp_SRCS
	mswin/klfwinclipboard.cpp
  )
  if(KLF_USE_WINSPARKLE)
    add_definitions(-DKLF_USE_WINSPARKLE -DKLF_WINSPARKLE_FEED_URL=\"${KLF_WINSPARKLE_FEED_URL}\")
    add_definitions(-I${KLF_WINSPARKLE_DIR})
    set(klfapp_MOCHEADERS ${klfapp_MOCHEADERS}
        mswin/klfwinsparkleupdater.h
    )
    set(klfapp_HEADERS ${klfapp_HEADERS}
        mswin/klfwinsparkleupdater.h
    )
    set(klfapp_SRCS ${klfapp_SRCS}
        mswin/klfwinsparkleupdater.cpp
    )
  endif(KLF_USE_WINSPARKLE)
endif(WIN32)
if(APPLE)
  set(klfapp_HEADERS ${klfapp_HEADERS}
	macosx/klfmacclipboard.h
  )
  set(klfapp_SRCS ${klfapp_SRCS}
	macosx/klfmacclipboard.cpp
	macosx/klfmainwin_mac.mm
	macosx/klfcmdifacedispatch_mac.mm
  )
  if(KLF_USE_SPARKLE)
    add_definitions(-DKLF_USE_SPARKLE -DKLF_SPARKLE_FEED_URL=\"${KLF_SPARKLE_FEED_URL}\")
    add_definitions(-I${KLF_SPARKLE_FRAMEWORK}/Headers)
    set(klfapp_MOCHEADERS ${klfapp_MOCHEADERS}
        macosx/klfsparkleupdater.h
    )
    set(klfapp_HEADERS ${klfapp_HEADERS}
        macosx/klfsparkleupdater.h
    )
    set(klfapp_SRCS ${klfapp_SRCS}
        macosx/klfsparkleupdater.mm
    )
  endif(KLF_USE_SPARKLE)
endif(APPLE)
# * X11
if(Q_WS_X11)
  set(klfapp_SRCS ${klfapp_SRCS}
	x11/klfx11.cpp
  )
endif(Q_WS_X11)
# * DBus
if(KLF_USE_DBUS)
  add_definitions(-DKLF_USE_DBUS)
  list(APPEND klfapp_SRCS
	klfdbus.cpp
  )
  list(APPEND klfapp_MOCHEADERS
	klfdbus.h
  )
  list(APPEND klfapp_HEADERS
	klfdbus.h
  )
endif(KLF_USE_DBUS)
if(KLF_DEBUG_USE_MODELTEST)
  add_definitions(-DKLF_DEBUG_USE_MODELTEST)
  set(klfapp_SRCS
	${klfapp_SRCS}
	modeltest.cpp
  )
  set(klfapp_MOCHEADERS
	${klfapp_MOCHEADERS}
	modeltest.h
  )
endif(KLF_DEBUG_USE_MODELTEST)

KLFInstHeaders(klfapp_INSTHEADERS "${klfapp_HEADERS}")
list(REMOVE_ITEM klfapp_INSTHEADERS
	# list more private headers here
	qtcolortriangle.h
	macosx/klfmacclipboard.h
)



# klfapp Library
# --------------

if(KLF_LIBKLFTOOLS_STATIC)
  # let main() know it has to initialize klftools' resource with  Q_INIT_RESOURCE(klftoolsres)
  add_definitions(-DKLF_LIBKLFTOOLS_STATIC)
endif(KLF_LIBKLFTOOLS_STATIC)

if(KLF_NO_CMU_FONT)
  add_definitions(-DKLF_NO_CMU_FONT)
endif(KLF_NO_CMU_FONT)

# Don't use CMAKE_INSTALL_PREFIX itself, as it is irrelevant for windows installers
# we need relative path
set(klf_share_dir_abs "${CMAKE_INSTALL_PREFIX}")
if(UNIX AND NOT KLF_MACOSX_BUNDLES)
  set(klf_share_dir_abs "${klf_share_dir_abs}/share/klatexformula")
endif(UNIX AND NOT KLF_MACOSX_BUNDLES)
KLFRelativePath(klf_share_dir "${KLF_ABS_INSTALL_BIN_DIR}" "${klf_share_dir_abs}")
KLFRelativePath(klf_share_rccresources_dir "${KLF_ABS_INSTALL_BIN_DIR}" "${KLF_ABS_INSTALL_RCCRESOURCES_DIR}")
if(KLF_MACOSX_BUNDLES OR IS_ABSOLUTE "${klf_share_dir}")
  set(klf_share_dir "") # let the program find out
endif(KLF_MACOSX_BUNDLES OR IS_ABSOLUTE "${klf_share_dir}")
if(KLF_MACOSX_BUNDLES OR IS_ABSOLUTE "${klf_share_rccresources_dir}")
  set(klf_share_rccresources_dir "") # let the program find out
endif(KLF_MACOSX_BUNDLES OR IS_ABSOLUTE "${klf_share_rccresources_dir}")
if(klf_share_dir)
  add_definitions(-DKLF_SHARE_DIR="${klf_share_dir}")
endif(klf_share_dir)
if(klf_share_rccresources_dir)
  add_definitions(-DKLF_SHARE_RCCRESOURCES_DIR="${klf_share_rccresources_dir}")
endif(klf_share_rccresources_dir)

# Uis, Mocs
qt4_wrap_ui(klfapp_UIS_H ${klfapp_UIS})
qt4_wrap_cpp(klfapp_MOC_CPPS ${klfapp_MOCHEADERS})
include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}"
	"${CMAKE_CURRENT_SOURCE_DIR}/klftools" "${CMAKE_CURRENT_SOURCE_DIR}/klfbackend")
set(klfapp_ALLSRC ${klfapp_SRCS} ${klfapp_UIS_H} ${klfapp_MOC_CPPS})

if(KLF_LIBKLFAPP_STATIC)
  add_library(klfapp STATIC ${klfapp_ALLSRC})
else(KLF_LIBKLFAPP_STATIC)
  add_library(klfapp SHARED ${klfapp_ALLSRC})
  if(KLF_MACOSX_BUNDLES)
    KLFMMakeFramework(klfapp ${klfapp_INSTHEADERS})
    set_target_properties(klfapp PROPERTIES
	MACOSX_FRAMEWORK_IDENTIFIER "org.klatexformula.klfapp"
	MACOSX_FRAMEWORK_SHORT_VERSION_STRING "${KLF_VERSION}"
	MACOSX_FRAMEWORK_BUNDLE_VERSION "${KLF_VERSION}"
    )
  endif(KLF_MACOSX_BUNDLES)
  set_target_properties(klfapp PROPERTIES
	VERSION "${KLF_LIB_VERSION}"
	SOVERSION "${KLF_LIB_VERSION}"
  )
endif(KLF_LIBKLFAPP_STATIC)
add_dependencies(klfapp klftools klfbackend)
target_link_libraries(klfapp ${QT_LIBRARIES} klfbackend klftools)
if(APPLE AND KLF_USE_SPARKLE)
  target_link_libraries(klfapp ${KLF_SPARKLE_FRAMEWORK})
endif(APPLE AND KLF_USE_SPARKLE)
if(WIN32 AND KLF_USE_WINSPARKLE)
  target_link_libraries(klfapp "${KLF_WINSPARKLE_DIR}/WinSparkle.dll")
endif(WIN32 AND KLF_USE_WINSPARKLE)
set_target_properties(klfapp PROPERTIES
	#	DEBUG_POSTFIX "${KLF_DEBUG_POSTFIX}"
	PUBLIC_HEADER "${klfapp_INSTHEADERS}"
)


# klatexformula Executable
# ------------------------

# Sources
set(klatexformula_SRCS
	main.cpp
	klfapp.cpp
)
set(klatexformula_MOCHEADERS
	klfapp.h
)
set(klatexformula_HEADERS
        ${klatexformula_MOCHEADERS}
)
# Translations
set(klatexformula_TSS
	i18n/klf_fr.ts
	i18n/klf_cs.ts
)
# Resources
set(klatexformula_QRCS
	klfres.qrc
)
# Translations
qt4_add_translation(klatexformula_QMS ${klatexformula_TSS})

# build the klf_xtradata.qrc file
set(klf_xtradata_res "${CMAKE_CURRENT_BINARY_DIR}/klf_xtradata.qrc")
file(WRITE "${klf_xtradata_res}" "<RCC>\n  <qresource prefix=\"i18n\">")
#  - add translations
foreach(qm ${klatexformula_QMS})
  get_filename_component(baseqmname  "${qm}"  NAME)
  file(APPEND "${klf_xtradata_res}"    "    <file alias=\"${baseqmname}\">${qm}</file>\n")
endforeach(qm)
file(APPEND "${klf_xtradata_res}" "  </qresource>\n")
#  - add fonts
file(APPEND "${klf_xtradata_res}" "  <qresource prefix=\"data/fonts\">\n")
foreach(fnt ${KLF_INCLUDE_FONTS})
  get_filename_component(basefntname "${fnt}" NAME)
  if(NOT IS_ABSOLUTE "${fnt}")
    set(fnt "${CMAKE_CURRENT_SOURCE_DIR}/${fnt}")
  endif(NOT IS_ABSOLUTE "${fnt}")
  file(APPEND "${klf_xtradata_res}"   "    <file alias=\"${basefntname}\">${fnt}</file>\n")
endforeach(fnt)
file(APPEND "${klf_xtradata_res}" "  </qresource>\n")
file(APPEND "${klf_xtradata_res}" "</RCC>\n")

list(APPEND klatexformula_QRCS "${klf_xtradata_res}")


qt4_add_resources(klatexformula_QRC_CPPS ${klatexformula_QRCS})
qt4_wrap_cpp(klatexformula_MOC_CPPS ${klatexformula_MOCHEADERS})
set(klatexformula_ALLSRC ${klatexformula_SRCS} ${klatexformula_QRC_CPPS} ${klatexformula_MOC_CPPS})
set(klatexformula_winrc)
if(MINGW)
  set(KLF_WIN_ICON "mswin\\\\klficon64.ico" CACHE STRING
	"Icon for klatexformula.exe program, relative to src/, with (escaped double-backslashes!)")
  file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/klatexformula.rc"
       "IDI_ICON1               ICON    DISCARDABLE     \"${KLF_WIN_ICON}\"\n")
  include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
  # windows .rc resource compilation for mingw
  ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/klatexformula.rc.o"
    COMMAND windres.exe -I"${CMAKE_CURRENT_SOURCE_DIR}"
    -i"${CMAKE_CURRENT_BINARY_DIR}/klatexformula.rc"
    -o "${CMAKE_CURRENT_BINARY_DIR}/klatexformula.rc.o"
  )

  set(klatexformula_ALLSRC ${klatexformula_ALLSRC}
			      "${CMAKE_CURRENT_BINARY_DIR}/klatexformula.rc.o")
endif(MINGW)

add_executable(klatexformula ${klatexformula_ALLSRC})
target_link_libraries(klatexformula ${QT_LIBRARIES} klfbackend klftools klfapp)


if(WIN32)
  # On debug versions, the application will open a console in which the debug output is shown.
  # Add the -mwindows only if we are not compiling in debug mode.
  # Add also a separate target klatexformula_cmdl to build the cmdl version, keeping the shell
  # window open.
  add_executable(klatexformula_cmdl ${klatexformula_ALLSRC})
  target_link_libraries(klatexformula_cmdl ${QT_LIBRARIES} klfbackend klftools klfapp)
  if(NOT KLF_DEBUG)
    set_target_properties(klatexformula  PROPERTIES LINK_FLAGS_RELEASE  "-Wl,-subsystem,windows")
    set_target_properties(klatexformula_cmdl  PROPERTIES LINK_FLAGS_RELEASE  "-Wl,-subsystem,console")
  endif(NOT KLF_DEBUG)
endif(WIN32)



if(KLF_MACOSX_BUNDLES)
  if (KLF_USE_SPARKLE)
    # this is needed for inside the info.plist
    get_filename_component(KLF_SPARKLE_DSA_PUBKEY_BASENAME "${KLF_SPARKLE_DSA_PUBKEY}" NAME)
  endif (KLF_USE_SPARKLE)

  # Set up the application bundle under Mac OS X
  set(KLF_BUNDLE_ICON_FILE "klficon.icns")
  configure_file(
    "${CMAKE_SOURCE_DIR}/src/macosx/Info.plist.in"
    "${CMAKE_CURRENT_BINARY_DIR}/Info.plist"
    @ONLY)
  set_target_properties(klatexformula PROPERTIES
        OUTPUT_NAME               klatexformula
        MACOSX_BUNDLE_ICON_FILE   klficon.icns
	MACOSX_BUNDLE_INFO_PLIST  "${CMAKE_CURRENT_BINARY_DIR}/Info.plist"
        MACOSX_BUNDLE_INFO_STRING "KLatexFormula version ${KLF_VERSION}"
        MACOSX_BUNDLE_GUI_IDENTIFIER "org.klatexformula.klatexformula"
        MACOSX_BUNDLE_LONG_VERSION_STRING "${KLF_VERSION}"
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${KLF_VERSION}"
        MACOSX_BUNDLE_BUNDLE_VERSION "${KLF_VERSION}"
        MACOSX_BUNDLE_BUNDLE_COPYRIGHT "Copyright (C) 2014 Philippe Faist"
  )
  KLFMMakeBundle(klatexformula)
  KLFMBundleMkPrivateDir(klatexformula "Contents/Resources/rccresources")
  
  # Add the frameworks to be included as private frameworks.
  KLFMBundlePrivateImportQtLib(klatexformula 	Core  "")
  KLFMBundlePrivateImportQtLib(klatexformula 	Gui   Core)
  KLFMBundlePrivateImportQtLib(klatexformula 	Xml   Core)
  KLFMBundlePrivateImportQtLib(klatexformula 	Sql   Core)
  if(KLF_USE_DBUS)
    KLFMBundlePrivateImportQtLib(klatexformula      DBus  "Core;Xml")
  endif(KLF_USE_DBUS)
  foreach(plugin ${KLF_BUNDLE_QT_PLUGINS})

=== src/klfbackend/CMakeLists.txt ===
# ################################################### #
# CMake project file for klatexformula/src/klfbackend #
# ################################################### #
# $Id: CMakeLists.txt 890 2014-07-25 13:03:20Z phfaist $
# ################################################### #

# Include our UseQt file here, so that we can require other configuration (not depend
# on so much qt libraries) as the main project.
set(QT_USE_QTXML TRUE)
include(${QT_USE_FILE})


if(KLF_EXTRA_SEARCH_PATHS)
  # Tell detectSettings() to go find latex at other locations, too
  set(klf_extra_search_paths "${KLF_EXTRA_SEARCH_PATHS}")
  # Transform ; list separators into C declaration string breaks
  string(REPLACE ";" "\",\"" klf_extra_search_paths "${klf_extra_search_paths}")
  add_definitions(-DKLF_EXTRA_SEARCH_PATHS="${klf_extra_search_paths}")
endif(KLF_EXTRA_SEARCH_PATHS)

include_directories(../klftools)

# Source files
set(klfbackend_SRCS
	klfbackend.cpp
	klfblockprocess.cpp
	klffilterprocess.cpp
	klflatexpreviewthread.cpp
	klfuserscript.cpp
)
set(klfbackend_MOCHEADERS
	klfblockprocess.h
	klflatexpreviewthread.h
	klflatexpreviewthread_p.h
)
set(klfbackend_HEADERS
	klfbackend.h
	klfbackend_p.h
	klfuserscript.h
	klffilterprocess.h
	${klfbackend_MOCHEADERS}
)

KLFInstHeaders(klfbackend_INSTHEADERS "${klfbackend_HEADERS}")

if(KLF_BUILD_BACKEND)
  qt4_wrap_cpp(klfbackend_MOC_CPPS ${klfbackend_MOCHEADERS})
  set(klfbackend_allsrc ${klfbackend_SRCS} ${klfbackend_MOC_CPPS})
  if (KLF_LIBKLFBACKEND_STATIC)
    add_library(klfbackend STATIC ${klfbackend_allsrc})
    set_target_properties(klfbackend PROPERTIES
      VERSION		${KLF_LIB_VERSION}
      )
  else(KLF_LIBKLFBACKEND_STATIC)
    add_library(klfbackend SHARED ${klfbackend_allsrc})
    set_target_properties(klfbackend PROPERTIES
      VERSION		${KLF_LIB_VERSION}
      SOVERSION		${KLF_LIB_VERSION}
      )
    if(KLF_MACOSX_BUNDLES)
      set(klfbackend_FRAMEWORKS ${KLF_BUNDLE_QT_FRAMEWORKS})
      KLFMMakeFramework(klfbackend "${klfbackend_FRAMEWORKS}" "${klfbackend_INSTHEADERS}")
    endif(KLF_MACOSX_BUNDLES)
  endif(KLF_LIBKLFBACKEND_STATIC)
  set_target_properties(klfbackend PROPERTIES
    #	      DEBUG_POSTFIX "${KLF_DEBUG_POSTFIX}"
    PUBLIC_HEADER "${klfbackend_INSTHEADERS}"
    )
  # add dependency on klftools
  target_link_libraries(klfbackend ${QT_LIBRARIES} klftools)
  add_dependencies(klfbackend klftools)
endif(KLF_BUILD_BACKEND)



# ---- KLFBACKEND_AUTO library:

if (KLF_BUILD_BACKEND_AUTO)

  # -- import sources from klftools to build *klfbackend_auto* library --
  set(klfbackend_auto_ADDSRCS
        ../klftools/klfdefs.cpp
        ../klftools/klfdebug.cpp
        ../klftools/klfutil.cpp
        ../klftools/klfdatautil.cpp
        ../klftools/klfpobj.cpp
        ../klftools/klffactory.cpp
    )
  set(klfbackend_auto_ADDMOCHEADERS
        ../klftools/klfdebug.h
    )
  set(klfbackend_auto_ADDHEADERS
        ../klftools/klfdefs.h
        ../klftools/klfutil.h
        ../klftools/klfdatautil.h
        ../klftools/klfpobj.h
        ../klftools/klffactory.h
        ../klftools/klfsysinfo.h
        ${klfbackend_auto_ADDMOCHEADERS}
    )
  # --
  
  KLFInstHeaders(klfbackend_auto_INSTHEADERS "${klfbackend_HEADERS};${klfbackend_auto_ADDHEADERS}")

  qt4_wrap_cpp(klfbackend_auto_MOC_CPPS ${klfbackend_MOCHEADERS} ${klfbackend_auto_ADDMOCHEADERS})
  set(klfbackend_auto_allsrc ${klfbackend_SRCS} ${klfbackend_auto_ADDSRCS} ${klfbackend_auto_MOC_CPPS})
  
  if (KLF_LIBKLFBACKEND_AUTO_STATIC)
    add_library(klfbackend_auto STATIC ${klfbackend_auto_allsrc})
    set_target_properties(klfbackend_auto PROPERTIES
      VERSION		${KLF_LIB_VERSION}
      )
  else(KLF_LIBKLFBACKEND_AUTO_STATIC)
    add_library(klfbackend_auto SHARED ${klfbackend_auto_allsrc})
    set_target_properties(klfbackend_auto PROPERTIES
      VERSION		${KLF_LIB_VERSION}
      SOVERSION		${KLF_LIB_VERSION}
      )
    if(KLF_MACOSX_BUNDLES)
      set(klfbackend_auto_FRAMEWORKS ${KLF_BUNDLE_QT_FRAMEWORKS})
      KLFMMakeFramework(klfbackend_auto "${klfbackend_auto_FRAMEWORKS}" "") #"${klfbackend_auto_INSTHEADERS}")
    endif(KLF_MACOSX_BUNDLES)
  endif(KLF_LIBKLFBACKEND_AUTO_STATIC)
endif(KLF_BUILD_BACKEND_AUTO)

set_target_properties(klfbackend_auto PROPERTIES
  #	      DEBUG_POSTFIX "${KLF_DEBUG_POSTFIX}"
  PUBLIC_HEADER "" # no need for headers(?), they're in klftools&klfbackend; "${klfbackend_auto_INSTHEADERS}"
  )
target_link_libraries(klfbackend_auto ${QT_LIBRARIES})




# Install Targets
# ---------------

if(KLF_BUILD_BACKEND)
  KLFInstallLibrary(klfbackend KLF_INSTALL_KLFBACKEND_ "${KLF_INSTALL_LIB_DIR}" "include/klfbackend")
  if(KLF_MACOSX_BUNDLES AND KLF_INSTALL_KLFBACKEND_FRAMEWORK)
    KLFMInstFrameworkUpdateId(
      "${KLF_INSTALL_LIB_DIR}/klfbackend.framework/Versions/${KLF_LIB_VERSION}/klfbackend"
      )
    # Installed library's dependency on klftools should be updated
    KLFMInstFrameworkUpdateLibChange(
      "${KLF_INSTALL_LIB_DIR}/klfbackend.framework/Versions/${KLF_LIB_VERSION}/klfbackend"
      "${CMAKE_CURRENT_BINARY_DIR}/klftools/klftools.framework/Versions/${KLF_LIB_VERSION}/klftools"
      "${KLF_INSTALL_LIB_DIR}/klftools.framework/Versions/${KLF_LIB_VERSION}/klftools"
      )
  endif(KLF_MACOSX_BUNDLES AND KLF_INSTALL_KLFBACKEND_FRAMEWORK)
endif(KLF_BUILD_BACKEND)


# --- and for klfbackend_auto :
if(KLF_BUILD_BACKEND_AUTO)
  KLFInstallLibrary(klfbackend_auto KLF_INSTALL_KLFBACKEND_AUTO_ "${KLF_INSTALL_LIB_DIR}" "")
  if(KLF_MACOSX_BUNDLES AND KLF_INSTALL_KLFBACKEND_AUTO_FRAMEWORK)
    KLFMInstFrameworkUpdateId(
      "${KLF_INSTALL_LIB_DIR}/klfbackend_auto.framework/Versions/${KLF_LIB_VERSION}/klfbackend_auto"
      )
  endif(KLF_MACOSX_BUNDLES AND KLF_INSTALL_KLFBACKEND_AUTO_FRAMEWORK)

endif(KLF_BUILD_BACKEND_AUTO)

=== src/klfkateplugin/CMakeLists.txt ===
# ###################################################### #
# CMake project file for klatexformula/src/klfkateplugin #
# ###################################################### #
# $Id: CMakeLists.txt 902 2014-08-09 23:44:15Z phfaist $
# ###################################################### #

# KLatexFormula KTextEditor Plugin

# NOTE: This CMakeLists.txt can either be included from the root CMakeLists.txt
#       to build the plugin, or the plugin can also be built separately by
#       calling directly this CMakeLists.txt as root build script, eg.
#         > cd src/klfkateplugin/
#         > mkdir build && cd build
#         build> cmake .. && make
#

message(STATUS "")
message(STATUS "[KDE4 SETTINGS (for kate plugin)]")

if(NOT KLF_ROOT_CMAKE_READ)
  include(../../cmake/KLFUtil.cmake)
endif(NOT KLF_ROOT_CMAKE_READ)

macro(klf_nokateplugin shortreason longreason)
  set(KLF_BUILD_KTEXTEDITORPLUGIN OFF CACHE BOOL "Build KTextEditor plugin" FORCE)
  KLFNote("${longreason}
    Please re-run cmake to proceed.")
  message(FATAL_ERROR "${shortreason}")
endmacro(klf_nokateplugin)

macro(klf_nokde4)
  klf_nokateplugin("KDE4 not found."
    "KDE4 is required to build KTextEditor plugin.
    Since KDE4 could not be found, the KLatexFormula KTextEditor plugin will not be built (KLF_BUILD_KTEXTEDITORPLUGIN).
    KLatexFormula itself does not need KDE4 and will be compiled normally.")
endmacro(klf_nokde4)

# find KDE4
find_package(KDE4)
if(NOT KDE4_KDECONFIG_EXECUTABLE)
  klf_nokde4()
endif(NOT KDE4_KDECONFIG_EXECUTABLE)

include(KDE4Defaults OPTIONAL RESULT_VARIABLE klf_kde4defaults_found)
if(NOT klf_kde4defaults_found)
  klf_nokde4()
endif(NOT klf_kde4defaults_found)
include_directories(${KDE4_INCLUDES})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../klftools")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../klfbackend")

mark_as_advanced(
	Automoc4_DIR
	KDE4_AUTH_POLICY_FILES_INSTALL_DIR
	KDE4_BUILD_TESTS
	KDE4_DATA_DIR
	KDE4_ENABLE_FINAL
	KDE4_ENABLE_FPIE
	KDE4_ENABLE_HTMLHANDBOOK
	KDE4_PLASMA_OPENGL_FOUND
	KDE4_SERIALIZE_TOOL
	KDE4_USE_COMMON_CMAKE_PACKAGE_CONFIG_DIR
)

# klfkateplugin plugin target

set(ktexteditor_klf_PART_SRCS klfkateplugin.cpp klfkteparser.cpp klfkateplugin_config.cpp )

if(KLF_LIBKLFTOOLS_STATIC OR KLF_LIBKLFBACKEND_STATIC)
  klf_nokateplugin("Can't build kate plugin with static klftools/klfbackend libraries."
    "KTextEditor plugin needs shared klftools and klfbackend libraries, but one or more of those libraries
    are being built statically. The KLatexFormula KTextEditor plugin will not be built (KLF_BUILD_KTEXTEDITORPLUGIN).
    KLatexFormula itself does not need the KTextEditor plugin and will be compiled normally.")
endif()


# This is not nice... just force user to build dynamic libraries.
#
#if(KLF_LIBKLFBACKEND_STATIC)
#  # Can't link the plugin to a static klfbackend library. We need to re-compile the klfbackend
#  # sources for this target.
#  get_target_property(klfbackend_sources klfbackend SOURCES)
#  foreach(klfbackend_sourcefile ${klfbackend_sources})
#    # TODO: this assumes that absolute paths are auto-generated sources (moc) and relative are
#    #       real sources...
#    if(NOT IS_ABSOLUTE ${klfbackend_sourcefile})
#      set(ktexteditor_klf_PART_SRCS ${ktexteditor_klf_PART_SRCS}
#				    "${CMAKE_SOURCE_DIR}/src/klfbackend/${klfbackend_sourcefile}")
#    else(NOT IS_ABSOLUTE ${klfbackend_sourcefile})
#    endif(NOT IS_ABSOLUTE ${klfbackend_sourcefile})
#  endforeach(klfbackend_sourcefile)
#  # add the moc file for klfdebug.h manually for automoc, since there isn't a klfdebug.cpp
#  set(ktexteditor_klf_PART_SRCS ${ktexteditor_klf_PART_SRCS}
#				    "${CMAKE_SOURCE_DIR}/src/klfbackend/klfdebug.h")
#endif(KLF_LIBKLFBACKEND_STATIC)

kde4_add_ui_files(ktexteditor_klf_PART_SRCS klfkatepluginconfigwidget.ui klfktepreviewwidget.ui)
kde4_install_icons(${ICON_INSTALL_DIR})
kde4_add_plugin(ktexteditor_klf ${ktexteditor_klf_PART_SRCS} )

target_link_libraries(ktexteditor_klf ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBS} ${KDE4_KIO_LIBS}
				       -lktexteditor )

if(KLF_ROOT_CMAKE_READ AND NOT KLF_LIBKLFBACKEND_STATIC)
  # link to our klfbackend
  target_link_libraries(ktexteditor_klf  klfbackend)
elseif(NOT KLF_ROOT_CMAKE_READ)
  # link to external klfbackend, we are being compiled externally
  target_link_libraries(ktexteditor_klf  -lklfbackend)
endif(KLF_ROOT_CMAKE_READ AND NOT KLF_LIBKLFBACKEND_STATIC)

install(TARGETS ktexteditor_klf DESTINATION "${PLUGIN_INSTALL_DIR}" )

########### install files ###############

install(FILES klfkatepluginui.rc DESTINATION "${DATA_INSTALL_DIR}/ktexteditor_klf" )

install(FILES ktexteditor_klf.desktop
              ktexteditor_klf_config.desktop DESTINATION "${SERVICES_INSTALL_DIR}" )

=== src/klftools/CMakeLists.txt ===
# ################################################# #
# CMake project file for klatexformula/src/klftools #
# ################################################# #
# $Id: CMakeLists.txt 903 2014-08-10 02:15:11Z phfaist $
# ################################################# #


# Include our UseQt file here, so that we can require other configuration (not depend
# on so much qt libraries) as the main project.
set(QT_USE_QTXML TRUE)
include(${QT_USE_FILE})


# Sources
set(klftools_SRCS
	klfdefs.cpp
	klfdebug.cpp
	klfcolorchooser.cpp
	klfpobj.cpp
	klfutil.cpp
        klfsysinfo.cpp
	klfdatautil.cpp
	klfconfigbase.cpp
	klfguiutil.cpp
	klffactory.cpp
	klfpixmapbutton.cpp
	klfpathchooser.cpp
	qtcolortriangle.cpp
	klfdisplaylabel.cpp
	klfsearchbar.cpp
	klfunitinput.cpp
	klflatexedit.cpp
	klfrelativefont.cpp
	klfenumlistwidget.cpp
	klfflowlayout.cpp
	klfflowlistwidget.cpp
	klfsidewidget.cpp
	klfpobjeditwidget.cpp
	klfadvancedconfigeditor.cpp
	klfitemviewsearchtarget.cpp
        klfprogerr.cpp
)
# Headers
#  * with QObject classes (needs moc)
set(klftools_MOCHEADERS
	klfdebug.h
	klfcolorchooser.h
	klfcolorchooser_p.h
	klfpixmapbutton.h
	klfguiutil.h
	klfpathchooser.h
	qtcolortriangle.h
	klfdisplaylabel.h
	klfunitinput.h
	klfsearchbar.h
	klflatexedit.h
	klflatexedit_p.h
	klfrelativefont.h
	klfenumlistwidget.h
	klfflowlayout.h
	klfflowlistwidget.h
	klfflowlistwidget_p.h
	klfsidewidget.h
	klfpobjeditwidget.h
	klfpobjeditwidget_p.h
	klfadvancedconfigeditor.h
	klfadvancedconfigeditor_p.h
	klfitemviewsearchtarget.h
	klfitemviewsearchtarget_p.h
        klfprogerr.h
)
#  * all headers
set(klftools_HEADERS
	klfdefs.h
	klfutil.h
	klfsysinfo.h
	klfdatautil.h
	klfdatautil_p.h
	klfconfigbase.h
	klfpobj.h
	klffactory.h
	klfiteratorsearchable.h
	klfsearchbar_p.h
	${klftools_MOCHEADERS}
)
# UI Forms
set(klftools_UIS
	klfcolorchoosewidget.ui
	klfcolordialog.ui
	klfsearchbar.ui
	klfadvancedconfigeditor.ui
        klfprogerr.ui
)
# Resources
set(klftools_QRCS
	../klftoolsres.qrc
)


if(APPLE)
  set(klftools_SRCS ${klftools_SRCS}
    macosx/klfdrawerdefs.mm
    klfdefs_mac.mm
    )
elseif(UNIX)
  set(klftools_SRCS ${klftools_SRCS}
    klfdefs_linux.cpp
    )
elseif(WIN32)
  set(klftools_SRCS ${klftools_SRCS}
    klfdefs_win.cpp
    )
endif(APPLE)


KLFInstHeaders(klftools_INSTHEADERS "${klftools_HEADERS}")

# our include directories
include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")

# Uis, Mocs, Qrcs
qt4_wrap_ui(klftools_UIS_H ${klftools_UIS})
qt4_wrap_cpp(klftools_MOC_CPPS ${klftools_MOCHEADERS})
qt4_add_resources(klftools_QRC_CPPS ${klftools_QRCS})


set(klftools_allsrc ${klftools_SRCS} ${klftools_QRC_CPPS} ${klftools_UIS_H} ${klftools_MOC_CPPS})
if (KLF_LIBKLFTOOLS_STATIC)
  add_library(klftools STATIC ${klftools_allsrc})
  set_target_properties(klftools PROPERTIES
	    VERSION		${KLF_LIB_VERSION}
  )
else(KLF_LIBKLFTOOLS_STATIC)
  add_library(klftools SHARED ${klftools_allsrc})
  target_link_libraries(klftools ${QT_LIBRARIES})
  set_target_properties(klftools PROPERTIES
	    VERSION		${KLF_LIB_VERSION}
	    SOVERSION		${KLF_LIB_VERSION}
  )
  if (APPLE)
    target_link_libraries(klftools "-framework IOKit")
    add_definitions(-I/System/Library/Frameworks/IOKit.framework/Headers)
  endif(APPLE)
  if(KLF_MACOSX_BUNDLES)
    set(klftools_FRAMEWORKS ${KLF_BUNDLE_QT_FRAMEWORKS})
    KLFMMakeFramework(klftools "${klftools_FRAMEWORKS}" "${klftools_INSTHEADERS}")
  endif(KLF_MACOSX_BUNDLES)
endif(KLF_LIBKLFTOOLS_STATIC)

set_target_properties(klftools PROPERTIES
		#	    DEBUG_POSTFIX "${KLF_DEBUG_POSTFIX}"
	    PUBLIC_HEADER "${klftools_INSTHEADERS}"
)

if(APPLE)
  set(KLF_APPKIT "/System/Library/Frameworks/AppKit.framework" CACHE FILEPATH "Path to AppKit framework")
  target_link_libraries(klftools "${KLF_APPKIT}")
endif(APPLE)



# Qt Designer Plugin
# ------------------
if(KLF_BUILD_TOOLSDESPLUGIN)
  include_directories("${QT_QTDESIGNER_INCLUDE_DIR}")
  qt4_wrap_cpp(klftoolsdesplugin_MOC_CPPS  klftools_desplugin.h)
  add_library(klftoolsdesplugin MODULE  klftools_desplugin.cpp ${klftoolsdesplugin_MOC_CPPS})
  set_target_properties(klftoolsdesplugin PROPERTIES
    COMPILE_DEFINITIONS "QT_PLUGIN;QT_NO_DEBUG;QDESIGNER_EXPORT_WIDGETS"
    SKIP_RPATH FALSE  INSTALL_RPATH "${QT_PLUGINS_DIR}/designer"
    COMPILE_FLAGS "-O2 -g"
    LINK_FLAGS "-O2 -g"
    )
  target_link_libraries(klftoolsdesplugin  klftools ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIBRARY} ${QT_QTDESIGNER_LIBRARY} ${QT_QTDESIGNERCOMPONENTS_LIBRARY})
endif(KLF_BUILD_TOOLSDESPLUGIN)

# Install Targets
# ---------------

KLFInstallLibrary(klftools KLF_INSTALL_KLFTOOLS_ "${KLF_INSTALL_LIB_DIR}" "include/klftools")
if(KLF_MACOSX_BUNDLES AND KLF_INSTALL_KLFTOOLS_FRAMEWORK)
  KLFMInstFrameworkUpdateId(
    "${KLF_INSTALL_LIB_DIR}/klftools.framework/Versions/${KLF_LIB_VERSION}/klftools"
  )
endif(KLF_MACOSX_BUNDLES AND KLF_INSTALL_KLFTOOLS_FRAMEWORK)

if(KLF_BUILD_TOOLSDESPLUGIN AND KLF_INSTALL_KLFTOOLSDESPLUGIN)
  install(TARGETS klftoolsdesplugin  LIBRARY DESTINATION "${KLF_INSTALL_DESPLUGIN_DIR}")
endif(KLF_BUILD_TOOLSDESPLUGIN AND KLF_INSTALL_KLFTOOLSDESPLUGIN)

=== src/plugins/CMakeLists.txt ===
# ################################################ #
# CMake project file for klatexformula/src/plugins #
# ################################################ #
# $Id: CMakeLists.txt 780 2012-05-12 13:41:36Z phfaist $
# ################################################ #


# We are no longer compiling KLF source !
remove_definitions(-DKLF_SRC_BUILD)


# The subdir in which to put plugins
set(KLF_CMAKE_BASEPLUGINSSUBDIR "${KLF_CMAKE_OS}-${KLF_CMAKE_ARCH}"
					CACHE INTERNAL "(internal) Base Plugins RCC sub-dir")

# THE PLUGIN TARGET/BASE NAMES

set(KLF_LOCAL_PLUGINS skin systrayicon buffers)
if(KLF_EXPERIMENTAL)
  # set(KLF_LOCAL_PLUGINS ${KLF_LOCAL_PLUGINS} wikiscan)
endif(KLF_EXPERIMENTAL)


add_custom_target(klfbaseplugins ALL)

#
# e.g. Usage: KLFPluginUndefOrLink(skin  libklftools libklfbackend libklfapp)
#
macro(KLFPluginUndefOrLink  plugin)
  KLFCMakeDebug("KLFPluginUndefOrLink: plugin=${plugin}")
  if(UNIX)  #includes Apple
    KLFCMakeDebug("UNIX.")
    KLFNoShlibUndefined("${plugin}")
  else(UNIX)
    KLFCMakeDebug("NOT UNIX.")
    target_link_libraries("${plugin}" ${ARGN})
  endif(UNIX)
endmacro(KLFPluginUndefOrLink)

# Setup per plugin
foreach(plugin ${KLF_LOCAL_PLUGINS})

  # Add the subdirectory
  add_subdirectory("${plugin}")

  # And set up a few more stuff
  string(TOUPPER "${plugin}" plugin_upper)
  KLFGetTargetLocation(plugin_location ${plugin})
  KLFGetTargetFileName(plugin_libname ${plugin})
  set(KLF_CMAKE_PLUGINS_LOCATION_${plugin_upper} "${plugin_location}")
  set(KLF_CMAKE_PLUGINS_LIBNAME_${plugin_upper} "${plugin_libname}")
  set(KLF_CMAKE_PLUGINS_LOCAL_LIBNAME_${plugin_upper}
    "${CMAKE_CURRENT_BINARY_DIR}/${KLF_CMAKE_PLUGINS_LIBNAME_${plugin_upper}}")
  add_custom_command(OUTPUT "${plugin_libname}"
	COMMAND "${CMAKE_COMMAND}" -E copy "${plugin_location}" "${plugin_libname}"
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        DEPENDS "${plugin}"
	COMMENT "Copying ${plugin_libname} to build root plugins/"
	VERBATIM
  )
  set(KLF_LOCAL_PLUGIN_LIBNAMES ${KLF_LOCAL_PLUGIN_LIBNAMES} ${plugin_libname})

  set(KLF_CMAKE_PLUGINS_QRC_DEFS
    "${KLF_CMAKE_PLUGINS_QRC_DEFS} <file>${plugin_libname}</file>"
  )

endforeach(plugin)



if(APPLE AND KLF_MACOSX_BUNDLES)
  KLFMMakeMacExtraBundledTarget(klfbaseplugins klatexformula "${KLF_LOCAL_PLUGIN_LIBNAMES}")

  foreach(plugin_libname ${KLF_LOCAL_PLUGIN_LIBNAMES})
    if(KLF_MACOSX_BUNDLE_EXTRAS_klatexformula)
      KLFMBundlePrivateLibUpdateQtDep(klfbaseplugins
	"${CMAKE_CURRENT_BINARY_DIR}/${plugin_libname}" "Core;Gui;Xml;Sql;DBus")
    endif(KLF_MACOSX_BUNDLE_EXTRAS_klatexformula)
    KLFMInstallNameToolChange(klfbaseplugins "${CMAKE_CURRENT_BINARY_DIR}/${plugin_libname}"
        "Frameworks/klfbackend.framework/Versions/${KLF_LIB_VERSION}/klfbackend"
        "${CMAKE_BINARY_DIR}/src/klfbackend/klfbackend.framework/Versions/${KLF_LIB_VERSION}/klfbackend")
    KLFMInstallNameToolChange(klfbaseplugins "${CMAKE_CURRENT_BINARY_DIR}/${plugin_libname}"
	"Frameworks/klftools.framework/Versions/${KLF_LIB_VERSION}/klftools"
	"${CMAKE_BINARY_DIR}/src/klftools/klftools.framework/Versions/${KLF_LIB_VERSION}/klftools")
    KLFMInstallNameToolChange(klfbaseplugins "${CMAKE_CURRENT_BINARY_DIR}/${plugin_libname}"
        "Frameworks/klfapp.framework/Versions/${KLF_LIB_VERSION}/klfapp"
        "${CMAKE_BINARY_DIR}/src/klfapp.framework/Versions/${KLF_LIB_VERSION}/klfapp")
  endforeach(plugin_libname)

endif(APPLE AND KLF_MACOSX_BUNDLES)


configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/plugindirinfo.xml.in"
  "${CMAKE_CURRENT_BINARY_DIR}/plugindirinfo.xml"
  @ONLY)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/info_baseplugins.xml.in"
  "${CMAKE_CURRENT_BINARY_DIR}/info_baseplugins.xml"
  @ONLY)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/klfbaseplugins.qrc.in"
  "${CMAKE_CURRENT_BINARY_DIR}/klfbaseplugins.qrc"
  @ONLY)


set(KLF_BASEPLUGINS_FN_RCC "klfbaseplugins-${KLF_VERSION}.rcc")

add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${KLF_BASEPLUGINS_FN_RCC}"
	COMMAND "${QT_RCC_EXECUTABLE}" -binary -o ${KLF_BASEPLUGINS_FN_RCC} klfbaseplugins.qrc
	WORKING_DIRECTORY  "${CMAKE_CURRENT_BINARY_DIR}"
	COMMENT  "Archiving Base Plugins into Add-On File"
	DEPENDS ${KLF_LOCAL_PLUGIN_LIBNAMES}
	  "${CMAKE_CURRENT_BINARY_DIR}/info_baseplugins.xml"
	  "${CMAKE_CURRENT_BINARY_DIR}/plugindirinfo.xml"
	  "${CMAKE_CURRENT_BINARY_DIR}/klfbaseplugins.qrc"
	VERBATIM
)
add_custom_target(klfbaseplugins_rcc ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${KLF_BASEPLUGINS_FN_RCC}")


if(APPLE AND KLF_MACOSX_BUNDLES)
  add_dependencies(klfbaseplugins_rcc klatexformula klfbaseplugins_maclibpacked)
  add_custom_command(TARGET klfbaseplugins_rcc POST_BUILD
      COMMAND cp "${CMAKE_CURRENT_BINARY_DIR}/${KLF_BASEPLUGINS_FN_RCC}"
		 "${klfbundlelocation_klatexformula}/Contents/Resources/rccresources/${KLF_BASEPLUGINS_FN_RCC}"
      COMMENT "Installing base plugins into application bundle"
      VERBATIM)
endif(APPLE AND KLF_MACOSX_BUNDLES)


if(WIN32)
  set(homePath "$ENV{USERPROFILE}")
else(WIN32)
  set(homePath "$ENV{HOME}")
endif(WIN32)
# local for-developers-only compile-time install
add_custom_target(klfbaseplugins_localinstall
  COMMAND "${CMAKE_COMMAND}" -E copy "${KLF_BASEPLUGINS_FN_RCC}" "${homePath}/.klatexformula/rccresources/"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMENT "Installing Base Plugins Add-On Locally in ~/.klatexformula/rccresources"
  VERBATIM
)
add_dependencies(klfbaseplugins_localinstall klfbaseplugins_rcc)
if(KLF_DEVEL_LOCAL_BASEPLUGINS_COPY)
  add_custom_target(klfbaseplugins_localinstall_all ALL)
  add_dependencies(klfbaseplugins_localinstall_all klfbaseplugins_localinstall)
endif(KLF_DEVEL_LOCAL_BASEPLUGINS_COPY)


if(KLF_INSTALL_PLUGINS)
  # The install target
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${KLF_BASEPLUGINS_FN_RCC}"
	  DESTINATION "${KLF_INSTALL_RCCRESOURCES_DIR}")
endif(KLF_INSTALL_PLUGINS)

=== src/plugins/buffers/CMakeLists.txt ===
# ######################################################### #
# CMake project file for klatexformula/src/plugins/buffers #
# ######################################################### #
# $Id: CMakeLists.txt 733 2011-09-16 15:41:13Z phfaist $
# ######################################################### #

set(buffers_SRCS
  buffers.cpp
)
set(buffers_HEADERS
  buffers.h
  openbufferslistwidget.h
  openbuffer.h
)
set(buffers_QRCS
  buffersdata.qrc
)
set(buffers_UIS
  openbufferswidget.ui
)

qt4_wrap_cpp(buffers_MOC_CPPS ${buffers_HEADERS})
qt4_wrap_ui(buffers_UIS_H ${buffers_UIS})
qt4_add_resources(buffers_QRC_CPPS ${buffers_QRCS})

add_library(buffers MODULE ${buffers_SRCS} ${buffers_MOC_CPPS} ${buffers_UIS_H} ${buffers_QRC_CPPS})

KLFPluginUndefOrLink(buffers  klftools klfbackend klfapp)

=== src/plugins/skin/CMakeLists.txt ===
# ##################################################### #
# CMake project file for klatexformula/src/plugins/skin #
# ##################################################### #
# $Id: CMakeLists.txt 733 2011-09-16 15:41:13Z phfaist $
# ##################################################### #

set(skin_SRCS
  skin.cpp
)
set(skin_HEADERS
  skin.h
)
set(skin_QRCS
  skindata.qrc
)
set(skin_UIS
  skinconfigwidget.ui
)

qt4_wrap_cpp(skin_MOC_CPPS ${skin_HEADERS})
qt4_wrap_ui(skin_UIS_H ${skin_UIS})
qt4_add_resources(skin_QRC_CPPS ${skin_QRCS})

add_library(skin MODULE ${skin_SRCS} ${skin_MOC_CPPS} ${skin_UIS_H} ${skin_QRC_CPPS})

KLFPluginUndefOrLink(skin  klftools klfbackend klfapp)

=== src/plugins/systrayicon/CMakeLists.txt ===
# ############################################################ #
# CMake project file for klatexformula/src/plugins/systrayicon #
# ############################################################ #
# $Id: CMakeLists.txt 733 2011-09-16 15:41:13Z phfaist $
# ############################################################ #

set(systrayicon_SRCS
  systrayicon.cpp
)
set(systrayicon_HEADERS
  systrayicon.h
)
set(systrayicon_UIS
  systrayiconconfigwidget.ui
  systraymainiconifybuttons.ui
)

qt4_wrap_cpp(systrayicon_MOC_CPPS ${systrayicon_HEADERS})
qt4_wrap_ui(systrayicon_UIS_H ${systrayicon_UIS})
add_library(systrayicon MODULE ${systrayicon_SRCS} ${systrayicon_MOC_CPPS} ${systrayicon_UIS_H})

KLFPluginUndefOrLink(systrayicon  klftools klfbackend klfapp)

=== debian/changelog ===
klatexformula (3.3.0~beta-1) unstable; urgency=medium

  * New upstream release
  * Minimum debian/rules file now using dh
  * Updated to standards version 3.9.6
  * Updated to debhelper 9
  * Removed menu file 
  * Removed uninstall target (Closes:  #803761)
  * Use updated watch file
  * Ammended .desktop file
  * Added hardening flags

 -- Tobias Winchen <winchen@physik.rwth-aachen.de>  Mon, 07 Dec 2015 23:13:37 +0100

=== debian/control ===
Source: klatexformula
Section: tex
Priority: extra
Maintainer: Tobias Winchen <winchen@physik.rwth-aachen.de> 
Build-Depends: debhelper (>= 9), docbook-to-man, cmake, libqt4-dev, pkg-kde-tools, kdelibs5-dev, libx11-dev, chrpath
Standards-Version: 3.9.6
Vcs-git: git://github.com/winchen/klatexformula_debian.git
Vcs-Browser: https://github.com/winchen/klatexformula_debian
Homepage: http://klatexformula.sourceforge.net/

Package: klatexformula
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI to easily get an image from a LaTeX formula or equation
 With klatexformula, just enter a formula and click "Evaluate" to get an image
 of a LaTeX formula. You can drag&drop, copy or save the resulting image
 directly from the GUI, which makes klatexformula a very convenient tool for
 presentations. Klatexformula also provides also tools for equation prototyping
 in LaTeX and a user-library of used equations.

Package: libklatexformula3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Runtime libraries for klatexformula 
 With Klatexformula, just enter a formula and click "Evaluate" to get an image
 of a LaTeX formula. You can drag&drop, copy or save the resulting image
 directly from the GUI, which makes klatexformula a very convenient tool for
 presentations. Klatexformula also provides also tools for equation prototyping
 in LaTeX and a user-library of used equations.
 This package provides the libraries klatexformula is based on.

Package: libklatexformula3-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libklatexformula3 (= ${binary:Version}) 
Description: Runtime libraries for klatexformula, development files 
 With Klatexformula, just enter a formula and click "Evaluate" to get an image
 of a LaTeX formula. You can drag&drop, copy or save the resulting image
 directly from the GUI, which makes klatexformula a very convenient tool for
 presentations. Klatexformula also provides also tools for equation prototyping
 in LaTeX and a user-library of used equations.
 This package contains the header files and static libraries to build the
 klatexformula libraries.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@ --parallel

override_dh_auto_configure:
	cmake . -DKLF_INSTALL_DESKTOP=TRUE -DKLF_INSTALL_KLFAPP_STATIC_LIBS=FALSE -DKLF_LIBKLFAPP_STATIC=FALSE -DKLF_LIBKLFBACKEND_STATIC=FALSE -DKLF_LIBKLFTOOLS_STATIC=FALSE -DKLF_INSTALL_APIDOC_DIR=share/doc/libklatexformula3-doc -DKLF_INSTALL_RCCRESOURCES_DIR=lib/klatexformula/rccresources -DKLF_INSTALL_LIB_DIR=lib -DKLF_INSTALL_DESPLUGIN_DIR=lib/klatexformula/qt4/plugins/designer 
	#-DKLF_INSTALL_RUN_POST_INSTALL=FALSE 
	#-DKLF_BUILD_BACKEND_AUTO=FALSE

override_dh_auto_build:
	/usr/bin/docbook-to-man debian/klatexformula.1.sgml > ${CURDIR}/debian/klatexformula.1
	dh_auto_build

override_dh_install:
	 chrpath -d $(CURDIR)/debian/tmp/usr/bin/klatexformula
	 chrpath -d $(CURDIR)/debian/tmp/usr/lib/libklfapp.so
	 chrpath -d $(CURDIR)/debian/tmp/usr/lib/libklfbackend.so
	 chrpath -d $(CURDIR)/debian/tmp/usr/lib/libklftools.so
	 dh_install

override_dh_clean:
	dh_clean
	rm -f Doxyfile.klftools
	rm -f Doxyfile.klfapp
	rm -f welcome_installer_withlatex.txt
	rm -f Doxyfile.klfbackend.sfweb
	rm -f Doxyfile.klfapp.sfweb
	rm -f cmake_uninstall.cmake
	rm -f klf_test_condition.cmake
	rm -f Doxyfile.klftools.sfweb
	rm -f klf_test_condition.cmake.in
	rm -f cmake_uninstall_script.cmake
	rm -f Doxyfile.klftools
	rm -f Doxyfile.klfbackend
	rm -f welcome_installer.txt
	rm -f src/klf_xtradata.qrc
	rm -f src/klatexformula.desktop
	rm -f src/plugins/info_baseplugins.xml
	rm -f src/plugins/plugindirinfo.xml
	rm -f src/plugins/klfbaseplugins.qrc
	rm -f src/klfkateplugin/ktexteditor_klf_automoc.cpp.files
	rm -f src/klatexformula.1.bkp.gz
	rm -f CMakeCache.txt
	rm -rf CMakeTmp/
	rm -rf src/CMakeFiles/
	rm -rf src/klfbackend/CMakeFiles/
	rm -rf src/klfbackend/__/
	rm -rf src/klfkateplugin/CMakeFiles/
	rm -rf src/klftools/CMakeFiles/
	rm -rf src/klftools/__/
	rm -rf src/plugins/CMakeFiles/
	rm -rf src/plugins/buffers/CMakeFiles/
	rm -rf src/plugins/skin/CMakeFiles/
	rm -rf src/plugins/systrayicon/CMakeFiles/

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)(beta\d*)$/$1~$2/ \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=sf/klatexformula \
.*=klatexformula(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
